var i, j, k;
var gTranslation; //will contain the stringbundle with some localized Strings "onload" // wird nach dem Laden das Stringbundle mit ein paar Übersetzungen enthalten
var gPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

/* Function resetPref()
 * Resets the Preference, given in the parameter aEntry.
 * Setzt die Einstellung, die im Parameter aEntry übergeben wird, zurück.
 */
function resetPref(aEntry)
{
    var nsIPrefService = Components.interfaces.nsIPrefService;
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService);
    try
    {
        var prefBranch = prefService.getBranch(null).QueryInterface(Components.interfaces.nsIPrefBranch2); //this is for Firefox 1.1
    }
    catch(e)
    {
        var prefBranch = prefService.getBranch(null).QueryInterface(Components.interfaces.nsIPrefBranchInternal); // this is for Firefox 1.0
    }
    prefBranch.clearUserPref(aEntry);
    debug("The Pref \"" + aEntry + "\" has succesfully been reset.");
    return true;
}

/* function debug()
 * Displays messages in javascript-console if extensions.searchengineordering.debug is true.
 * Schribt Text in die JavaScript-Konsole, wenn extensions.searchengineordering.debug true ist.
*/
function debug(aString)
{
    try
    {
        if(gPrefs.getBoolPref("extensions.searchengineordering.debugmode.enabled") === true)
        {
            var consoleService = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
            consoleService.logStringMessage("Search Engine Ordering: " + aString);
            return true;
        }
        dump("Search Engine Ordering: " + aString);
    }
    catch(e) 
    {
        gPrefs.setBoolPref("extensions.searchengineordering.debugmode.enabled",false);
        dump("Search Engine Ordering: " + aString);
    }
    return false;
}

/* Function move()
 * Moves the search plugin up or down in the tree view and saves the changes.
 * Verschiebt die Suchmaschinen nach oben oder unten und speichert die Änderungen.
 */
function move(aTarget)
{
    var tree = document.getElementById('tree');
    var index = tree.currentIndex;
    if(tree.view.selection.getRangeCount() > 1)
        return false;
    var id = aTarget.getAttribute("id");
    if(id !== "searchengineordering-up-button" && id !== "searchengineordering-down-button")
        return false;
    var move = (id === "searchengineordering-up-button") ? -1 : 1;
    if((move === -1 && index === 0) || (move === 1 && index === tree.childNodes[2].childNodes.length - 1))
        return false;
    var current = tree.childNodes[2].childNodes[index];
    var other = tree.childNodes[2].childNodes[index + move];
    gPrefs.setCharPref("browser.search.order." + (index + 1).toString(), other.childNodes[0].childNodes[2].getAttribute("label"));
    gPrefs.setCharPref("browser.search.order." + (index + 1 + move).toString(), current.childNodes[0].childNodes[2].getAttribute("label"));
    other.childNodes[0].childNodes[0].setAttribute("label",index);
    if(move === -1) // Direction: up
    {
        current.childNodes[0].childNodes[0].setAttribute("label",(((index < 10) ? "0" : "") + index.toString()));
        other.childNodes[0].childNodes[0].setAttribute("label",(((index + 1 < 10) ? "0" : "") + (index + 1).toString()));
        tree.childNodes[2].insertBefore(current,other);
    }
    else //Direction: down
    {
        other.childNodes[0].childNodes[0].setAttribute("label",(((index + 1 < 10) ? "0" : "") + (index + 1).toString()));
        current.childNodes[0].childNodes[0].setAttribute("label",(((index + 2 < 10) ? "0" : "") + (index + 2).toString()));
        tree.childNodes[2].insertBefore(other,current);
    }
    tree.view.selection.select(index + move);
    return true;
}

/* Function treeOrder()
 * Saves the order of the search plugins.
 * Speichert die Reihenfolge der Search Plugins.
 */
function treeOrder()
{
    debug("treeOrder() is running")
    var ti = document.getElementById("tree").childNodes[2].childNodes;
    var noPref = false;
    var currentLabel = " ", currentPref = " ";
    var existent = false;
    for(i = 0; i < ti.length; i++)
    {
        currentLabel = ti[i].childNodes[0].childNodes[2].getAttribute("label");
        try      { currentPref = gPrefs.getCharPref("browser.search.order." + (i+1).toString()); }
        catch(e) { noPref = true;                                                                }
        if(gPrefs.getPrefType("browser.search.order." + (i+1).toString() !== gPrefs.PREF_STRING) || noPref === true)
        {
            for(j = i; j < ti.length; j++)
            {
                gPrefs.setCharPref("browser.search.order." + (j+1).toString(), ti[j].childNodes[0].childNodes[2].getAttribute("label"));
            }
            break;
        }
        if(currentLabel !== currentPref)
        {
            for(j = i; j < ti.length; j++)
            {
                if(ti[j].childNodes[0].childNodes[2].getAttribute("label") === currentPref)
                {
                    existent = true;
                    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
                    var flag = 1*2 + 256*127 + 65536*127;
                    var button = prompts.confirmEx(window, 'Search Engine Ordering', gTranslation.getString("noRestart"), flag, "cancel", gTranslation.getString("oldOrder"), gTranslation.getString("closeFirefox"), null, {value:false});
                    if(button === 0)
                    {
                        window.close();
                        return false;
                    }
                    if(button === 2)
                    {
                        try
                        {
                            opener.goQuitApplication();
                        }
                        catch(e)
                        {
                            try
                            {
                                var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
                                var win = wm.getMostRecentWindow(type);
                                win.goQuitApplication();
                            }
                            catch(e)
                            {
                                window.close();
                            }
                        }
                        return false;
                    }
                    if(button === 1)
                    {
                        for(j = 0; j < ti.length; j++)
                        {
                            gPrefs.setCharPref("browser.search.order." + (j+1).toString(), ti[j].childNodes[0].childNodes[2].getAttribute("label"));
                        }
                        return true;
                    }
                }
            }
            if(!existent) // There is a pref which points to non-existing search plugin
                gPrefs.setCharPref("browser.search.order." + (i+1).toString(), currentLabel);
        }
    }
    debug("treeOrder() has finished");
    return true;
}

/* Function trreeNumber()
 * Gives every row its number.
 * Schreibt die Spalte Nummer
 */
function treeNumber()
{
    debug("treeNumber() is running");
    var ti = document.getElementById("tree").childNodes[2].childNodes;
    for(i = (arguments[0] !== undefined) ? arguments[0] : 0; i < ti.length; i++)
    {
        ti[i].childNodes[0].childNodes[0].setAttribute("label",(i < 9) ? ( "0" + (i+1).toString()) : (i+1).toString());
        debug(ti[i].childNodes[0].childNodes[2].getAttribute("label") + " is the " + (i+1).toString() + "th Search Plugin.");
    }
    debug("treeNumber() has finished");
}

/* Function loading()
 * Starts all the functions that have to be opened at startup.
 * Führt alle Funktionen aus, die beim starten gestartet werden müssen.
 */
function loading()
{
    debug("loading() has started");
    gTranslation = document.getElementById("translation");
    try
    {
        i = gPrefs.getBoolPref("extensions.searchengineordering.reset.ask");
    }
    catch(e)
    {
        gPrefs.setBoolPref("extensions.searchengineordering.reset.ask",true);
    }
    try
    {
        i = gPrefs.getBoolPref("extensions.searchengineordering.debugmode.enabled");
    }
    catch(e)
    {
        gPrefs.setBoolPref("extensions.searchengineordering.debugmode.enabled",false);
    }
    try
    {
        i = gPrefs.getBoolPref("extensions.searchengineordering.openintab");
    }
    catch(e)
    {
        gPrefs.setBoolPref("extensions.searchengineordering.openintab",false);
    }
    i = null;
    var debugmode = gPrefs.getBoolPref("extensions.searchengineordering.debugmode.enabled");
    document.getElementById("searchengineordering-options-debugmode").checked = debugmode;
    document.getElementById("searchengineordering-options-debugmode").hidden = !debugmode;
    var tab = gPrefs.getBoolPref("extensions.searchengineordering.openintab");
    document.getElementById("searchengineordering-options-openintab").checked = tab;
    treeOrder();
    treeNumber();
    debug("loading() has finished");
}

/* Funtion tooglePrefs()
 * Sets a given preference to true if it's value is flase and to false if it's value is true.
 * Verändert den Wert einer übergebenen Einstellung von true auf false oder andersherum.
 */
function togglePref(aSuffix)
{
    var prefix = "extensions.searchengineordering.";
    gPrefs.setBoolPref(prefix + aSuffix, !gPrefs.getBoolPref(prefix + aSuffix));
    return true;
}


/* Function mycroft()
 * Opens mycroft webpage for installing new search plugins.
 * Öffnet die Mycroft-Webseite, um neue Search-Plugins installieren können.
 */
function mycroft()
{
    var tab = gPrefs.getBoolPref("extensions.searchengineordering.openintab");
    if(tab)
    {
        try
        {
            opener.gBrowser.addTab("http://mycroft.mozdev.org");
            return true;
        }
        catch(e)
        {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
            var recentWindow = wm.getMostRecentWindow("navigator:browser");
            if (recentWindow) 
            {
                // Use an existing browser window
                recentWindow.delayedOpenTab(url);       
            }
            else
            {
                // No browser windows are open, so open a new one.
                window.open(url);
            }
        }
    }
    window.open("http://mycroft.mozdev.org/","Mycroft");
    document.getElementById("searchengineordering-options-downloadmore").childNodes[0].style.color = gPrefs.getCharPref("browser.visited_color");
    return true;
}

/* Function deleteOrder()
 * Iterates through the gPrefs and resets them.
 * Geht alle Einstellungen durch und setzt sie zurück.
 */
function deleteOrder()
{
    if(gPrefs.getBoolPref("extensions.searchengineordering.reset.ask") === false)
    {
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
        var check = {value:false}, flag = 1027, okorcancel;
        okorcancel = prompts.confirmEx(window, "Search Engine Ordering", gTranslation.getString("resetQuestion"), flag, "3", "4", "", gTranslation.getString("dontAskAgain"), check);
        if(check.value === true && okorcancel === 0)
            gPrefs.setBoolPref("extensions.searchengineordering.reset.ask",false);
        if(okorcancel !== 0)
            return false;
    }
    for(i = 0; gPrefs.getPrefType("browser.search.order." + (i+1).toString()) === gPrefs.PREF_STRING; i++)
    {
	resetPref("browser.search.order." + (i+1).toString());
    }
    return true;
}

/* Function alphabetic()
 * Sorts the search plugins alphabetically.
 * Sortiert die Search Plugins alphabetisch.
 */
function alphabetic()
{
    var treeItem = document.getElementById("tree").childNodes[2].childNodes;
    var allLabels = Array();
    for(i = 0; i < treeItem.length; i++)
    {
        allLabels[i] = treeItem[i].childNodes[0].childNodes[2].getAttribute("label");
    }
    allLabels.sort();
    for(i = 0; i < treeItem.length; i++)
    {
        treeItem[i].childNodes[0].childNodes[2].setAttribute("label", allLabels[i]);
        gPrefs.setCharPref("browser.search.order." + (i+1).toString(), allLabels[i]);
        treeItem[i].childNodes[0].childNodes[1].removeAttribute("src");
    }
}

/* Function deleteEngine()
 * Deletes the cuurently selected search plugin.
 * Löscht das gerade markierete Search Plugin.
 */
function deleteEngine()
{
    var selected = document.getElementById("tree").currentIndex;
    var item = document.getElementById("tree").childNodes[2].childNodes[selected].childNodes[0];
    var itemName = item.childNodes[2].getAttribute("label");
    var itemLocation = item.childNodes[1].getAttribute("src");
    itemLocation = Array(itemLocation.substring(0,itemLocation.lastIndexOf(".")) + ".src",itemLocation);
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    var flag = 1027;
    var okorcancel = prompts.confirmEx(window, "Search Engine Ordering", gTranslation.getString("delete1") + itemName + gTranslation.getString("delete2"), flag, "3", "4", "", null, {value:false});
    if(okorcancel === 0)
    {
        var url2file = Components.classes["@mozilla.org/network/protocol;1?name=file"].createInstance(Components.interfaces.nsIFileProtocolHandler);
        var file1 = url2file.getFileFromURLSpec(itemLocation[0]);
        var file2 = url2file.getFileFromURLSpec(itemLocation[1]);
        if(!file1.isWritable() || !file2.isWritable())
        {
            prompts.alert(window,'Search Engine Ordering',gTranslation.getString("deleteNoRights"));
            debug("This User hasn\'t got the rights to delete the files!");
            return false;
        }
        if(file1.exists() && file1.isWritable())
        {
            file1.remove(false);
            debug(file1.path + " succesfully deleted!");
        }
        if(file2.exists() && file2.isWritable())
        {
            file2.remove(false);
            debug(file2.path + " succesfully deleted!");
        }
        document.getElementById('tree').childNodes[2].removeChild(document.getElementById('tree').childNodes[2].childNodes[selected]);
        treeNumber(selected);
        prompts.alert(window,'Search Engine Ordering',gTranslation.getString('removed'));
    }
    else if(okorcancel === 1)
        return false;
    return true;
}